# $Revision: 1.28 $, $Date: 2005/05/19 16:16:17 $
# TODO:
# - kill unaligned accesses (create_db,gpre_current,gbak_static,isql_static) on alpha
# - create classic server/super server subpackaged and drop bcond
#   (see firebird2 on debian how to do it)
%bcond_with	ss	# Super Server
Summary:	Firebird SQL Database Server and Client tools
Summary(pl):	Firebird - serwer baz danych SQL oraz narzdzia klienckie
Summary(de):	Firebird - relationalen Open-Source- Datenbankmanagementsystems
Name:		Firebird
# FirebirdCS/FirebirdSS (Classic Server/Super Server)?
Version:	1.5.2.4731
Release:	1
License:	Interbase Public License 1.0
Group:		Applications/Databases
Source0:	http://dl.sourceforge.net/firebird/firebird-%{version}.tar.bz2
# Source0-md5:	fea53ed5213cff4bd96513fb1a6c0ca2
Source1:	http://www.ibphoenix.com/downloads/60All.zip
# Source1-md5:	f86a132012361cd4ae88563105741a4c
Source2:	http://www.ibphoenix.com/downloads/ib_4_0_docs.tar.gz
# Source2-md5:	f4176d5dec952ee774bb8ee74c1f715d
Source3:	http://www.ibphoenix.com/downloads/isc_docs.zip
# Source3-md5:	66eef71c188215d10988788282c014a7
Source4:	firebird.init
Source5:	firebird.sysconfig
Source6:	firebird.inetd
Patch0:		%{name}-chmod.patch
Patch1:		%{name}-editline.patch
Patch2:		%{name}-env-overflows.patch
Patch3:		%{name}-va.patch
Patch4:		%{name}-morearchs.patch
URL:		http://firebird.sourceforge.net/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	libtool
BuildRequires:	libstdc++-devel
BuildRequires:	ncurses-devel
BuildRequires:	rpmbuild(macros) >= 1.213
BuildRequires:	unzip
Requires:	%{name}-lib = %{version}-%{release}
# official ports are x86, sparc and x86_64
# alpha and ppc added in morearchs patch
# see morearchs patch if you want to add support for more archs
ExclusiveArch:	%{ix86} %{x8664} sparc sparcv9 alpha ppc
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		ibdir	%{_libdir}/interbase
%define		specflags	-fno-strict-aliasing
%define		debugcflags	-O1 -g -Wall -fno-strict-aliasing

%description
Firebird is a powerful, high-performance relational database designed
to be embedded into applications on multiple platforms.

%description -l pl
Firebird jest potnym, wysoko wydajnym systemem relacyjnych baz
danych zaprojektowanym do osadzania w aplikacjach na wielu
platformach.

%description -l de
Firebird ist der Open-Source-Spin-Off des weiterhin kommerziell von
Borland vertriebenen relationalen Datenbankmanagementsystemes
InterBase. Die Abspaltung erfolgte im Jahre 2000 als kurz vor Freigabe
der Version 6 des kommerziellen Vorgngers Interbase bei Borland
ernsthafte berlegungen im Gange waren, die Weiterentwicklung
einzustellen.

Aus Interbase 6.0 wurde Firebird 1.0, wobei dies als eine
Bugfix-Version mit nur wenigen Erweiterungen angesehen werden kann.
Eine Erweiterung von Firebird 1.0 ist der 64-Bit File I/O, so dass
auch Datenbankdateien ber 2GB erzeugt werden knnen.

%package lib
Summary:	Firebird shared library
Summary(pl):	Biblioteka wspdzielona Firebird
Group:		Libraries

%description lib
Firebird shared library (libgds).

%description lib -l pl
Biblioteka wspdzielona Firebird (libgds).

%package devel
Summary:	Header files for Firebird library
Summary(pl):	Pliki nagwkowe biblioteki Firebird
Group:		Development/Libraries
Requires:	%{name}-lib = %{version}-%{release}
Requires:	libstdc++-devel

%description devel
Header files for Firebird library.

%description devel -l pl
Pliki nagwkowe biblioteki Firebird.

%package static
Summary:	Static Firebird library
Summary(pl):	Statyczna biblioteka Firebird
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static Firebird library (libgds).

%description static -l pl
Statyczna biblioteka Firebird (libgds).

%package doc
Summary:	Extensive InterBase and Firebird documentation
Summary(pl):	Obszerna dokumentacja do baz InterBase i Firebird
Group:		Documentation

%description doc
Extensive InterBase and Firebird documentation.

%description doc -l pl
Obszerna dokumentacja do baz InterBase i Firebird.

%prep
%setup -q -n firebird-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

install -d docs/{IB3.0,IB4.0,IB6.0}
unzip -q %{SOURCE1} -d docs/IB6.0
tar xzf %{SOURCE2} -C docs/IB4.0
unzip -q %{SOURCE3} -d docs/IB3.0
# standardize extension, also avoids gzipping by compress-doc
mv -f docs/IB6.0/LANGREF.{PDF,pdf}

%build
cd src/extern/editline
cp -f /usr/share/automake/config.* .
%{__autoconf}
cd ../../..
%{__libtoolize}
%{__aclocal}
%{__autoconf}

%configure \
	%{?with_ss:--enable-superserver} \
	--prefix=%{ibdir} \
	%{?debug:--enable-debug}

# OPTFLAGS for editline
export OPTFLAGS="%{rpmcflags}"
%ifarch %{x8664}
DARCH="-DAMD64"
%else
%ifarch sparc sparcv9
DARCH="-Dsparc"
%else
DARCH=""
%endif
%endif
%{__make} -j1 \
	PROD_FLAGS="%{rpmcflags} -DNDEBUG -DLINUX -pipe -MMD -fPIC $DARCH" \
	DEV_FLAGS="%{rpmcflags} -DLINUX -DDEBUG_GDS_ALLOC -pipe -MMD -fPIC -Wall -Wno-switch $DARCH" \
	LIB_LINK_RPATH_LINE= \
	LIB_CLIENT_LINK_OPTIONS="-lpthread"

# fb_lock_mgr is started during build - try to stop it (if /proc is mounted...)
/sbin/fuser -k gen/firebird/bin/fb_lock_mgr 2>/dev/null || :

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C src -f ../gen/Makefile.install buildImageDir

install -d $RPM_BUILD_ROOT/etc/{rc.d/init.d,sysconfig/rc-inetd}
install -d $RPM_BUILD_ROOT{%{ibdir},%{_libdir},%{_includedir}} \
	$RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

install gen/firebird/lib/libfb*.a $RPM_BUILD_ROOT%{_libdir}
cd gen/buildroot/%{ibdir}

cp -af UDF bin help intl aliases.conf firebird.conf firebird.msg security.fdb \
	$RPM_BUILD_ROOT%{ibdir}
install include/* $RPM_BUILD_ROOT%{_includedir}
cp -df lib/* $RPM_BUILD_ROOT%{_libdir}
install examples/* $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

# or libfbembed?
ln -sf libfbclient.so.1 $RPM_BUILD_ROOT%{_libdir}/libgds.so.0
ln -sf libfbclient.so.1 $RPM_BUILD_ROOT%{_libdir}/libgds.so

ln -sf libfbstatic.a $RPM_BUILD_ROOT%{_libdir}/libgds.a

install %{SOURCE4}	$RPM_BUILD_ROOT/etc/rc.d/init.d/firebird
install %{SOURCE5}      $RPM_BUILD_ROOT/etc/sysconfig/firebird
install %{SOURCE6}	$RPM_BUILD_ROOT/etc/sysconfig/rc-inetd/firebird
%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 145 firebird
%useradd -u 145 -d %{ibdir} -s /bin/sh -g firebird -c "Firebird Server" firebird

%if %{with ss}
%post
/sbin/chkconfig --add firebird
if [ -f /var/lock/subsys/firebird ]; then
	/etc/rc.d/init.d/firebird restart >&2
else
	echo "Run \"/etc/rc.d/init.d/firebird start\" to start firebird." >&2
fi

%preun
if [ "$1" = "0" ]; then
	if [ -f /var/lock/subsys/firebird ]; then
		/etc/rc.d/init.d/firebird stop
	fi
	/sbin/chkconfig --del firebird
fi
%endif

%postun
if [ "$1" = "0" ]; then
	%userremove firebird
	%groupremove firebird
fi

%post	lib -p /sbin/ldconfig
%postun	lib -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc doc/{sql.extensions,Firebird_conf.txt,README.user*,WhatsNew,fb2-todo.txt}
%attr(755,root,root) %{_libdir}/libib_util.so
%dir %{ibdir}
%attr(755,root,root) %{ibdir}/UDF
%attr(755,root,root) %{ibdir}/bin
%{ibdir}/help
%dir %{ibdir}/intl
%attr(755,root,root) %{ibdir}/intl/fbintl
%{ibdir}/firebird.msg
# following files should be in /var (*.fdb) and /etc (*.conf)?
%{ibdir}/security.fdb
%{ibdir}/aliases.conf
%{ibdir}/firebird.conf
%if %{with ss}
%attr(754,root,root) /etc/rc.d/init.d/firebird
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/firebird
%else
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/rc-inetd/firebird
%endif

%files lib
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libfbclient.so.*.*.*
%attr(755,root,root) %{_libdir}/libfbembed.so.*.*.*
# InterBase/old Firebird compatibility symlinks
%attr(755,root,root) %{_libdir}/libgds.so.0
# needed here - original libgds.so.0 didn't have soname, so some old
# (possibly not open-source) apps may be linked with libgds.so
%attr(755,root,root) %{_libdir}/libgds.so

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libfbclient.so
%attr(755,root,root) %{_libdir}/libfbembed.so
%{_includedir}/*.h
%{_examplesdir}/%{name}-%{version}

%files static
%defattr(644,root,root,755)
%{_libdir}/libfbcommon.a
%{_libdir}/libfbstatic.a
# compat link
%{_libdir}/libgds.a

%files doc
%defattr(644,root,root,755)
%doc docs/*

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: Firebird.spec,v $
Revision 1.28  2005/05/19 16:16:17  qboosh
- changed libgds.so.0 symlink to more update-resistant

Revision 1.27  2005/05/11 13:17:29  qboosh
- use x8664 macro

Revision 1.26  2005/05/01 17:31:30  glen
- use %useradd/%groupadd macros

Revision 1.25  2005/03/23 11:53:06  spider
- added german description

Revision 1.24  2005/02/21 22:18:11  arekm
- add inetd script for CS version

Revision 1.23  2005/02/21 21:07:46  arekm
- add init/sysconfig scripts

Revision 1.22  2004/12/29 09:36:41  hawk
- updated to 1.5.2.4731

Revision 1.21  2004/10/25 10:02:34  qboosh
- release 3

Revision 1.20  2004/10/10 18:29:43  paladine
- added missing BR: autoconf,automake,libtool

Revision 1.19  2004/10/08 12:34:24  qboosh
- more updates in morearchs patch, now builds on alpha (but triggers unaligned traps)

Revision 1.18  2004/10/03 01:36:13  havner
- updated morearch patch
- rel 2

Revision 1.17  2004/08/13 18:16:52  radek
- release 1 (why not?)

Revision 1.16  2004/08/08 11:45:07  qboosh
- try to kill fb_lock_mgr after build

Revision 1.15  2004/08/08 11:27:20  qboosh
- sparc patch replaced by -Dsparc, adjusted morearchs patch

Revision 1.14  2004/08/08 10:53:15  qboosh
- updated to 1.5.1.4500 (bugfixes, am64 port)
- removed obsolete link,types patches, updated sparc,morearchs patches

Revision 1.13  2004/05/30 00:52:18  qboosh
- release 1 (it's in better state than 1.0.2.x)

Revision 1.12  2004/05/30 00:51:26  qboosh
- merged DEVEL

Revision 1.11.2.9  2004/05/29 18:01:25  qboosh
- not ready for parallel build

Revision 1.11.2.8  2004/05/29 17:26:38  qboosh
- builds on ppc now; 64-bit port is broken, needs too much work

Revision 1.11.2.7  2004/05/29 16:05:59  qboosh
- readded env-overflows patch (still some left)

Revision 1.11.2.6  2004/05/29 14:38:07  qboosh
- va fix, some tries with other archs, debug fixes, no-strict-aliasing

Revision 1.11.2.5  2004/05/28 18:29:26  qboosh
- there is sparc32-linux port - added sparc patch, builds now; updated EA

Revision 1.11.2.4  2004/05/28 06:04:27  qboosh
- libgds.so.0 should point to always existing file (to avoid removal by ldconfig)

Revision 1.11.2.3  2004/05/28 06:00:34  qboosh
- added missing ldconfig

Revision 1.11.2.2  2004/05/24 23:06:39  qboosh
- updated chmod,link patches, build/install/files sections
- client lib builds, server still needs some work

Revision 1.11.2.1  2004/05/23 22:01:53  qboosh
- started update to 1.5.0 final, NFY

Revision 1.11  2003/10/29 21:01:54  qboosh
- added link patch to fix libgds linking (use -ldl -lcrypt, added soname)
- added chmod patch to avoid security problems during build (*EVIL* perms)
- added env-overflows patch which removes direct overflows through "INTERBASE"
  (and similar) environment vars, mentioned in CAN-2003-0281
- release 2

Revision 1.10  2003/06/12 14:25:39  qboosh
- added gcc33 patch

Revision 1.9  2003/05/26 16:24:18  malekith
- massive attack: adding Source-md5

Revision 1.8  2003/05/25 11:00:50  malekith
- massive attack, adding Source-md5

Revision 1.7  2003/05/25 05:45:21  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.6  2003/03/14 09:52:56  qboosh
- use http for sources on sourceforge

Revision 1.5  2003/02/28 10:06:57  trojan
- massive attack: perl -pi -e "s/^#+\%\{/#\%\%\{/"

Revision 1.4  2003/01/29 11:47:12  qboosh
- only x86 is supported for now

Revision 1.3  2003/01/23 20:18:43  qboosh
- updated to 1.0.2.908
- removed obsolete isc4.gbak file and bootkit-missing,ksh patches
- updated fix patch

Revision 1.2  2002/12/24 17:13:07  qboosh
- added some InterBase/Firebird docs (as subpackage - it's huge, even package)

Revision 1.1  2002/12/05 21:30:25  qboosh
- only builds (Classic version for now)
